import { Component, OnInit } from '@angular/core';
import { IonButton, IonContent, IonInput, IonTextarea } from '@ionic/angular/standalone';
import { FmodeChatCompletion, MarkdownPreviewModule } from 'fmode-ng';

@Component({
  selector: 'app-page-juben',
  templateUrl: './page-juben.component.html',
  styleUrls: ['./page-juben.component.scss'],
  imports: [IonButton, IonContent, IonTextarea, IonInput, MarkdownPreviewModule
  ],
  standalone: true,
})
export class PageJubenComponent implements OnInit {
  constructor() { }
  ngOnInit() { }
  // 用户输入提示词
  environment: string = "山势雄伟，植被丰富，白云飘浮，给人营造出仙境的感觉"
  environmentInput(ev: any) {
    this.environment = ev.detail.value;
  }
  // 用户输入提示词
  userPrompt: string = "山势雄伟，植被丰富，白云飘浮，给人营造出仙境的感觉"
  promptInput(ev: any) {
    this.userPrompt = ev.detail.value;
  }
  // 属性：组件内用于展示消息内容的变量
  responseMsg: any = ""
  // 方法：实例化completion对象，传入消息数组，并订阅生成的可观察对象。
  isComplete: boolean = false; // 定义完成状态属性，用来标记是否补全完成
  sendMessage() {
    console.log("create")

    let PromptTemplate = `
    您作为一名专业的沉浸式文旅策划大师，以下是該景區的描述${this.environment}，请帮我发掘该景区可以创作的剧本元素，包括角色设定、文化故事、剧本逻辑设置。
    以下是剧本大纲：${this.userPrompt}
    `

    let completion = new FmodeChatCompletion([
      { role: "system", content: "" },
      { role: "user", content: PromptTemplate }
    ])
    completion.sendCompletion().subscribe((message: any) => {
      // 打印消息体
      console.log(message.content)
      // 赋值消息内容给组件内属性
      this.responseMsg = message.content
      if (message?.complete) { // 判断message为完成状态，则设置isComplete为完成
        this.isComplete = true
      }
    })
  }

}
